using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Net.Sockets;
using System.Runtime.Remoting;
using System.Text;
using System.Windows.Forms;
using Lightstreamer.DotNet.Server;
using Lightstreamer.Interfaces.Data;
using Nms.Server.Test;

namespace NmsPushClient
{
    public partial class NmsPushClient : Form
    {
        string equip;
        string equipStatus;
        Nms.Server.Test.NmsServerAdapter adapter;
        Nms.Server.Test.LiteralBasedProvider metaAdapter;
        
        public NmsPushClient()
        {
            System.Collections.IDictionary metaParams = new Hashtable();
            System.Collections.IDictionary dataParams = new Hashtable();
            InitializeComponent();
            
            adapter = new Nms.Server.Test.NmsServerAdapter();
            metaAdapter = new LiteralBasedProvider();

            try
            {
                metaParams["max_bandwidth"] = "40";
                metaParams["max_frequency"] = "3";
                metaParams["buffer_size"] = "30";
 //               MetadataProviderServer metadataServer = new MetadataProviderServer();
                DataProviderServer dataServer = new DataProviderServer();
                dataServer.Adapter = (IDataProvider)adapter;
                //metadataServer.Adapter = metaAdapter;
                //metadataServer.AdapterParams = dataParams;
                //metadataServer.AdapterConfig = @"C:\Lightstreamer\adapters\NmsServer2\bin\DotNetServer_N2.exe.config";
                dataServer.AdapterParams = metaParams;
                dataServer.AdapterConfig = @"C:\Lightstreamer\adapters\NmsServer2\bin\DotNetServer_N2.exe.config";

                string host = "LMCOC11008437";
                TcpClient metadataRRSocket = new TcpClient(host, 6663);
                TcpClient dataRRSocket = new TcpClient(host, 6661);
                TcpClient dataNotifySocket = new TcpClient(host, 6662);

                //metadataServer.RequestStream = metadataRRSocket.GetStream();
                //metadataServer.ReplyStream = metadataRRSocket.GetStream();
                dataServer.RequestStream = dataRRSocket.GetStream();
                dataServer.ReplyStream = dataRRSocket.GetStream();
                dataServer.NotifyStream = dataNotifySocket.GetStream();

                dataServer.Name = "NMSTEST";

                dataServer.Start();
            } catch( Exception ex)
            {
                int i = 0;
                i = i + 1;
                Console.WriteLine(ex);
            }
        }

        private void equip1RadioButton_CheckedChanged(object sender, EventArgs e)
        {
            equip = "EQUIPMENT 1";
        }

        private void equip2RadioButton_CheckedChanged(object sender, EventArgs e)
        {
            equip = "EQUIPMENT 2";
        }

        private void equip3RadioButton_CheckedChanged(object sender, EventArgs e)
        {
            equip = "EQUIPMENT 3";
        }

        private void greenStatusRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            equipStatus = "1";
        }

        private void yellowStatusRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            equipStatus = "2";
        }

        private void redStatusRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            equipStatus = "3";
        }

        private void pushButton_Click(object sender, EventArgs e)
        {
            System.Collections.IDictionary eventData = new Hashtable();

            eventData["equipName"] = this.equip;
            eventData["status"] = this.equipStatus;
            adapter.OnEvent("item1", eventData, false);
        }

    }
}